<template lang="pug">
.row
  .gt-sm.col-sm-4.col-md-3
    LeaderBoard

  .col-12.col-sm-12.col-md-9
    ModerationFilter(
      :terms="terms",
      :langlabel="$t('source_language')",
      showLocked="true"
    )
    FilterMessage(:terms="terms")
    //- .q-my-md LIST ALL MEDIA ITEMS WITH STATUS OF 'readyformanualsubtitle' CONTENT BY OLDEST FIRST, CONTINUOUS PAGING FILTER BY LANGUAGE GETTING TRANSCRIBED (IE TARGET LANG)

    q-infinite-scroll(scroll-target="body", ref="scroller", @load="onLoad")
      template(v-slot:loading)
        .row.justify-center.q-my-md
          q-spinner-dots(color="primary", size="40px")

      .text-center(v-if="!filtered.length") {{ $t('no_transcription_match') }}.

      q-card.overflow-hidden.q-mb-sm(
        v-for="media in filtered",
        flat,
        :key="media.id",
        bordered,
        :class="{ 'border-primary': isMine(media), 'light-dimmed': isOthers(media) || alreadyAttempted(media) }"
      )
        .bg-warning.q-pa-sm.text-white(v-if="media.notes") {{ media.notes }}
        //- div {{media}}
        q-card-section(:horizontal="$q.screen.gt.xs")
          q-card-section.col-auto.text-center.relative(style="width: 135px")
            .column.justify-between.full-height
              .col-auto
                q-chip {{ codeToLang(media.srcLang) }}
              .col
                div
                  .text-h5 {{ getScore(media) }}

          q-separator(:vertical="$q.screen.gt.xs")

          q-card-section.col.relative
            q-icon.float-left.on-left(
              size="lg",
              :name="fabYoutube",
              color="red"
            )
            .text-body-1 {{ $t('youtube_msg1') }}
            .text-body-1 {{ $t('youtube_msg2') }}
            q-btn.absolute-bottom-right.q-ma-sm(
              outline,
              v-if="isMine(media)",
              icon="smart_display",
              @click="openYouTube(media)"
            ) {{ $t('open_youtube_caption_editor') }}
              //- q-tooltip Open YouTube caption editor

          q-separator(:vertical="$q.screen.gt.xs")
          q-card-actions.justify-around(:vertical="$q.screen.gt.xs")
            slot
              q-btn(
                flat,
                round,
                v-if="!isMine(media) && !isOthers(media)",
                icon="lock",
                @click="lock(media)"
              )
                q-tooltip(v-if="!isMine(media) && !isOthers(media)") {{ $t('lock_for_myself') }}
                q-tooltip(v-if="isMine(media)") {{ $t('locked_for_me') }}
              q-btn(
                v-if="isMine(media)",
                flat,
                round,
                color="black",
                icon="lock_open",
                @click="unlock(media)"
              )
                q-tooltip {{ $t('unlock') }}
              q-btn(
                v-if="isMine(media)",
                flat,
                round,
                color="warning",
                icon="unpublished",
                @click="needHelp(media)"
              )
                q-tooltip {{ $t('need_help') }}
              q-btn(
                v-if="isMine(media)",
                flat,
                round,
                color="positive",
                icon="check",
                @click="saveTranscription(media)"
              )
                q-tooltip {{ $t('its_done') }}
</template>

<script>
import LeaderBoard from "@/components/LeaderBoard";
import ModerationFilter from "@/components/ModerationFilter";
import FilterMessage from "@/components/FilterMessage";
import LangItem from "@/components/LangItem";
import { db, FieldValue, Timestamp } from "@/db";
import { findIndex, last, filter } from "lodash";
import { mapState } from "vuex";
import Language from "@/mixins/Language";
import { openURL } from "quasar";
import { DateTime } from "luxon";
import { fabYoutube } from "@quasar/extras/fontawesome-v5";

export default {
  mixins: [Language],
  created() {
    this.fabYoutube = fabYoutube;
  },
  data: () => {
    return {
      terms: { showLocked: false },
      media: [],
      config: {},
    };
  },
  methods: {
    async needHelp(item) {
      // console.log("saving");
      Object.assign(item, {
        targetText: item.targetText || "",
        notes: this.$t("already_attempted_may_be_more_difficult."),
        activeUser: null,
        attemptedBy: `users/${this.user.id}`,
        attemptedAt: FieldValue.serverTimestamp(),
      });
      try {
        await db.collection("media").doc(item.id).update(item);

        let index = findIndex(this.media, { id: item.id });
        this.$set(this.media, index, item);
      } catch (e) {
        this.showError(e);
      }
    },
    async saveTranscription(item) {
      // console.log("saving");
      try {
        if (
          (typeof item.targetText == "undefined" ||
            item.targetText.length == 0) &&
          typeof item.type == "undefined"
        )
          throw new Error(this.$t("no_text_entered"));
        Object.assign(item, {
          status: "readyformanualtranslate",
          activeUser: null,
          transcribedBy: `users/${this.user.id}`,
          transcribedAt: FieldValue.serverTimestamp(),
        });

        await db.collection("media").doc(item.id).update(item);
      } catch (e) {
        this.showError(e);
      }
    },
    async unlock(item) {
      // console.log("saving");
      Object.assign(item, {
        activeUser: null,
        markedActiveAt: null,
      });

      await db.collection("media").doc(item.id).update({
        activeUser: null,
        markedActiveAt: null,
      });

      let index = findIndex(this.media, { id: item.id });
      this.$set(this.media, index, item);
    },

    async lock(item) {
      // console.log("saving");
      Object.assign(item, {
        activeUser: `users/${this.user.id}`,
        markedActiveAt: FieldValue.serverTimestamp(),
      });

      await db
        .collection("media")
        .doc(item.id)
        .update({
          activeUser: `users/${this.user.id}`,
          markedActiveAt: FieldValue.serverTimestamp(),
        });

      let index = findIndex(this.media, { id: item.id });
      this.$set(this.media, index, item);
    },
    getScore() {
      return this.config.score_map["transcript"];
    },
    alreadyAttempted(item) {
      return item.attemptedBy && item.attemptedBy == `users/${this.user.id}`;
    },
    isMine(item) {
      return item.activeUser && item.activeUser == `users/${this.user.id}`;
    },
    isOthers(item) {
      return item.activeUser && item.activeUser != `users/${this.user.id}`;
    },
    async onLoad(index, done) {
      await this.getTranscriptionJobs(done);
    },
    async openYouTube(lang) {
      openURL(`https://studio.youtube.com/video/${lang.youtube}/translations`);
    },
    async getTranscriptionJobs(done) {
      try {
        let current = DateTime.now().minus({ days: 1 });
        let timestamp = Timestamp.fromDate(current.toJSDate());
        let ref = db
          .collection("media")
          .where("status", "==", "readyformanualsubtitle")
          .where("uploadedAt", "<", timestamp);

        if (this.terms.lang) {
          ref = ref.where("srcLang", "==", this.terms.lang);
        }

        if (this.terms.showLocked) {
          ref = ref.where("activeUser", "==", `users/${this.user.id}`);
        }

        ref = ref.orderBy("uploadedAt", "desc");
        ref = ref.orderBy("createdAt", "asc");

        if (this.media.length > 0) {
          let lastl = last(this.media);
          let lastref = lastl._doc;
          ref = ref.startAfter(lastref);
        }

        ref = ref.limit(10);

        await this.$bind("tmpsubs", ref, {
          maxRefDepth: 1,
        });

        this.tmpsubs.forEach((doc) => {
          this.media.push(doc);
        });
        let length = this.tmpsubs.length;

        // Prevent from receiving updates automatically
        this.$unbind("tmpsubs", true);

        if (done) done(length == 0);
        else this.$refs.scroller.stop();
      } catch (e) {
        console.log(e);
        this.showError(e);
      }
    },
  },
  computed: {
    filtered() {
      return filter(this.media, {
        status: "readyformanualsubtitle",
      });
    },
    ...mapState({
      user: (state) => state.user,
    }),
  },
  components: {
    LeaderBoard,
    ModerationFilter,
    FilterMessage,
    LangItem,
  },
  watch: {
    terms: {
      deep: true,
      async handler() {
        this.media = [];
        this.$refs.scroller.reset();
        this.$refs.scroller.resume();
        this.$refs.scroller.trigger();
      },
    },
  },
  firestore: {
    config: db.collection("config").doc("meta"),
  },
};
</script>

<style lang="scss" scoped>
// @import "@/styles/quasar.variables.scss";

.border-primary {
  border-color: #21ba45 !important;
}
</style>
